package com.example;

import akka.actor.typed.ActorRef;
import akka.actor.typed.Behavior;
import akka.actor.typed.javadsl.AbstractBehavior;
import akka.actor.typed.javadsl.ActorContext;
import akka.actor.typed.javadsl.Behaviors;
import akka.actor.typed.javadsl.Receive;

public class ConsumerFactory extends AbstractBehavior<ConsumerFactory.Message> {

    public interface Message {};

    public record Start(int amount) implements Message {  }

    public static Behavior<Message> create(ActorRef<Queue.Message> queue) {
        return Behaviors.setup(context -> new ConsumerFactory(context, queue));
    }

    private final ActorRef<Queue.Message> queue;

    private ConsumerFactory(ActorContext<Message> context, ActorRef<Queue.Message> queue) {
        super(context);
        this.queue = queue;
    }

    @Override
    public Receive<Message> createReceive() {
        return newReceiveBuilder()
                .onMessage(Start.class, this::onStart)
                .build();
    }

    private Behavior<Message> onStart(Start msg) {
        for(int i=0; i < msg.amount; i++) {
            this.getContext().spawnAnonymous(Consumer.create(this.queue));
        }
        return this;
    }
}
